/* LIGHT.CPP */
/* 280205: Started programming */

#include "sps2wrap.h"
#include "dma.h"
#include <memory.h>
#include "light.h"

using namespace KazMaths;

int dma_normal,dma_faint,current_light=-1;

void setup_light() {
  dma_normal=VIFStaticDMA.GetPointer();
  VIFStaticDMA.Add32(FLUSH);
  VIFStaticDMA.Add32(STCYCL(1,1));
  VIFStaticDMA.Add32(BASE(16));
  VIFStaticDMA.Add32(OFFSET(504));
  VIFStaticDMA.AddUnpack(V4_32, 0, 8);
  VIFStaticDMA.AddVector(Vector4(2048, 2048, (0xFFFFFF / 32.0f), 1));
  Vector3 LightDir1(0, 1, 1);
  Vector3 LightDir2(1, 1, 0);
  Vector3 LightDir3(0,0,1);
  Vector3 LightDir4(0, 0, 1);
  LightDir1.NormaliseSelf();
  LightDir2.NormaliseSelf();
  LightDir3.NormaliseSelf();
  LightDir4.NormaliseSelf();
  VIFStaticDMA.AddVector(Vector4(LightDir1.x,LightDir2.x,LightDir3.x,
                                        LightDir4.x));
  VIFStaticDMA.AddVector(Vector4(LightDir1.y,LightDir2.y,LightDir3.y,
                                        LightDir4.y));
  VIFStaticDMA.AddVector(Vector4(LightDir1.z,LightDir2.z,LightDir3.z,
                                        LightDir4.z));
  VIFStaticDMA.AddVector(Vector4(128,128,128,0  ));
  VIFStaticDMA.AddVector(Vector4(64 ,64 ,64 ,0  ));
  VIFStaticDMA.AddVector(Vector4(32 ,32 ,32 ,0  ));
  VIFStaticDMA.AddVector(Vector4(0  ,0  ,0  ,0  ));
  VIFStaticDMA.DMARet();
  dma_faint=VIFStaticDMA.GetPointer();
  VIFStaticDMA.Add32(FLUSH);
  VIFStaticDMA.Add32(STCYCL(1,1));
  VIFStaticDMA.Add32(BASE(16));
  VIFStaticDMA.Add32(OFFSET(504));
  VIFStaticDMA.AddUnpack(V4_32, 0, 8);
  VIFStaticDMA.AddVector(Vector4(2048, 2048, (0xFFFFFF / 32.0f), 1));
  Vector3 LightDir1b(0, 1, 1);
  Vector3 LightDir2b(1, 1, 0);
  Vector3 LightDir3b(0,0,1);
  Vector3 LightDir4b(0, 0, 1);
  LightDir1b.NormaliseSelf();
  LightDir2b.NormaliseSelf();
  LightDir3b.NormaliseSelf();
  LightDir4b.NormaliseSelf();
  VIFStaticDMA.AddVector(Vector4(LightDir1b.x,LightDir2b.x,LightDir3b.x,
                                        LightDir4b.x));
  VIFStaticDMA.AddVector(Vector4(LightDir1b.y,LightDir2b.y,LightDir3b.y,
                                        LightDir4b.y));
  VIFStaticDMA.AddVector(Vector4(LightDir1b.z,LightDir2b.z,LightDir3b.z,
                                        LightDir4b.z));
  VIFStaticDMA.AddVector(Vector4(64,64,64,0  ));
  VIFStaticDMA.AddVector(Vector4(32 ,32 ,32 ,0  ));
  VIFStaticDMA.AddVector(Vector4(16 ,16 ,16 ,0  ));
  VIFStaticDMA.AddVector(Vector4(0  ,0  ,0  ,0  ));
  VIFStaticDMA.DMARet();
}

void set_light(int how) {
  if(how==current_light) return;
  current_light=how;
  switch(how) {
    case 0:
      VIFDynamicDMA.DMACall(dma_faint);
      return;
    case 1:
      VIFDynamicDMA.DMACall(dma_normal);
      return;
  }
}
