/* SOUNDBYTE.CPP - Programmed by Maarten Hofman */
/* 150404: Started programming */
/* 190404: Added has_name() */
/* 210404: Added set_link and get_link */

#include <stdio.h>
#include <malloc.h>
#include <unistd.h>
#include <sys/stat.h>
#include <assert.h>
#include <string.h>

#include "soundbyte.h"

soundbyte::soundbyte() {
  loc=0;
  stream=NULL;
  fragsize=235;
  fragments=0;
  link=NULL;
}

soundbyte::~soundbyte() {
  if(stream) free(stream);
}

soundbyte *soundbyte::get_link() {
soundbyte *tmp;

  tmp=link;
  link=NULL;
  return tmp;
}

void soundbyte::set_link(soundbyte *how) {
  link=how;
}

int soundbyte::has_name(char *how) {
  return !strcmp(name,how);
}

void soundbyte::set_fragment_size(int how) {
  fragsize=how;
}

void soundbyte::reset() {
  loc=0;
}

unsigned char *soundbyte::get_next_fragment() {
  if(loc>=fragments) return NULL;
  return &stream[(loc++)*fragsize];
}

void soundbyte::Load(char *filename) {
struct stat file_stat;
FILE *fp;
int i;
long filesize;
char buf[100];

  strncpy(name,filename,32);
  sprintf(buf,"%s%s.raw",AUDIO_DIR,filename);
  printf("Loading file %s\n",buf);
  if(stat(buf,&file_stat)<0) {
    printf("Failed to stat file!\n");
    return;
  }
  printf("Finished with the file stat.\n");
  filesize=file_stat.st_size;
  printf("File size: %ld\n",filesize);
  assert(fragsize>0);
  fragments=filesize/fragsize;
  fragments++;
  printf("Number of fragments: %ld\n",fragments);
  stream=(unsigned char *)malloc(fragments*fragsize);
  fp=fopen(buf,"r");
  if(!fp) {
    printf("Failed to open file!\n");
    return;
  }
  for(i=0;i<filesize;i++) {
    stream[i]=fgetc(fp);
  }
  for(i=filesize;i<fragments*fragsize;i++) stream[i]=0x80;
  fclose(fp);
}

